#!/usr/local/bin/perl
# Author: Himanshu Jain

if ($ARGV[0] eq "")
{
    die "Which file to clean!\n";
}

$filename = $ARGV[0];
open (READ_DATA, $filename);

$writefile= $ARGV[0].".clean";
open (WRITEFILE, ">".$writefile);

$line = <READ_DATA>;


print $line,"\n";

$total_time = 0;
$total_problems = 0;
$problems_solved = 0;
$max_time = -1;
$problem_name = "";

$line = <READ_DATA>;
print $line,"\n";

$line = <READ_DATA>;


@ta = split(/ +/, $line);

$timeout= $ta[1];

print "timeout = $timeout\n";


while ($line ne "") 
{
    chop ($line);

    if ($line =~ /PERLBENCH/) 
    { 
	@b = split(/ +/, $line);
	
	$total_problems = $total_problems + 1;

	$mquit = 0;

	$seensuccess=0;
	if ($line =~ /SUCCESS/)
	{
	    $seensuccess=1;
	}

	$line = <READ_DATA>;

	$resultfound=0;

	while (($line ne "") && ($mquit == 0)) 
	{
	    chop ($line);
	    if ($line =~ /UNSATISFIABLE/ || $line =~ /unsatisfiable/) 
	    { 
		print "$b[2] $line \n";
		print WRITEFILE "$b[2] UNSATISFIABLE $b[12]\n";

		$total_time = $total_time + $b[12];
		$problems_solved = $problems_solved + 1;

		$mquit = 1;
		$line = <READ_DATA>;
		$resultfound=1;
	    }
	    elsif ($line =~ /SATISFIABLE/ || $line =~ /satisfiable/)
	    {
		print "$b[2] $line \n";
		print WRITEFILE "$b[2] SATISFIABLE $b[12]\n";

		$total_time = $total_time + $b[12];
		$problems_solved = $problems_solved + 1;

		$mquit = 1;
		$line = <READ_DATA>;
		$resultfound=1;
	    }
	    elsif ($line =~ /PERLBENCH/)
	    {
#		print WRITEFILE "$b[2] UNKNOWN\n";
		$mquit = 1;
	    }
	    else
	    {
		$line = <READ_DATA>;
	    }
	}

	if ($seensuccess==1 && $resultfound==0)
	{
	    print "@b encountered success but no definite result\n";
	    print WRITEFILE "$b[2] UNKNOWN $timeout\n";
	}

	if ($seensuccess==0 && $resultfound==0)
	{
	    print WRITEFILE "$b[2] UNKNOWN $timeout\n";
	}

	if ($seensuccess==0 && $resultfound==1)
	{
	    die "@b failed but a result obtained\n";
	}
	
    }
    else
    {
	$line = <READ_DATA>;
    }
}

close(READ_DATA);
close(WRITEFILE);


#print WRITEFILE "#Timeout per problem in seconds: $timeout \n";
#print WRITEFILE "#Solved $problems_solved out of $total_problems \n";
#print WRITEFILE "#Solved $problems_solved problems in $total_time seconds \n";

print "Timeout per problem in seconds: $timeout \n";
print "Solved $problems_solved out of $total_problems \n";
print "Solved $problems_solved problems in $total_time seconds \n";


$total_time            = $total_time + ($problems_not_solved *  $timeout);

print "Total time spent including timeouts $total_time seconds \n";
#print WRITEFILE "#Total time spent including timeouts $total_time seconds \n";

