module main (i, clock);
input clock;
input [25:0]i,j,k;
reg [25:0]x,y,z;



initial x    = 0;
initial y    = 0;
initial z    = 0;

always @ (posedge clock) begin
	x <= x + 1048576*i;
	y <= y + 2097152*j;
	z <= z + 4194304*k;
end


always begin
assert prop1: (4*x-2*y+z !=1048576);
assert prop2: (4*x-2*y+z != 2097152);
assert prop3: (4*x-2*y+z !=4);
end
endmodule
